Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 7990)
@@ -27,5 +27,5 @@
    !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!            3.6  !  2014-11  (P. Mathiot) add ice shelf capability
-   !!            4.0  !  2017-04  (G. Madec)  Remove CPP keys
+   !!            4.0  !  2017-04  (G. Madec)  remove CPP ddm key & avm at t-point only 
    !!----------------------------------------------------------------------
 
@@ -159,5 +159,5 @@
       !!
       !! ** Action  :   compute en (now turbulent kinetic energy)
-      !!                update avt, avmu, avmv (before vertical eddy coef.)
+      !!                update avt, avm (before vertical eddy coef.)
       !!
       !! References : Gaspar et al., JGR, 1990,
@@ -175,19 +175,13 @@
 #endif
       !
-      IF( kt /= nit000 ) THEN   ! restore before value to compute tke
-         avt (:,:,:) = avt_k (:,:,:) 
-         avm (:,:,:) = avm_k (:,:,:) 
-         avmu(:,:,:) = avmu_k(:,:,:) 
-         avmv(:,:,:) = avmv_k(:,:,:) 
-      ENDIF 
-      !
-      CALL tke_tke      ! now tke (en)
-      !
-      CALL tke_avn      ! now avt, avm, avmu, avmv
-      !
-      avt_k (:,:,:) = avt (:,:,:) 
-      avm_k (:,:,:) = avm (:,:,:) 
-      avmu_k(:,:,:) = avmu(:,:,:) 
-      avmv_k(:,:,:) = avmv(:,:,:) 
+      avt(:,:,:) = avt_k(:,:,:)     ! restore before Kz computed with TKE alone
+      avm(:,:,:) = avm_k(:,:,:) 
+      !
+      CALL tke_tke                  ! now tke (en)
+      !
+      CALL tke_avn                  ! now avt, avm, dissl
+      !
+      avt_k(:,:,:) = avt(:,:,:)     ! store Kz computed with TKE alone
+      avm_k(:,:,:) = avm(:,:,:) 
       !
 #if defined key_agrif
@@ -195,5 +189,7 @@
       IF( .NOT.Agrif_Root() )   CALL Agrif_Update_Tke( kt )      ! children only
 #endif      
-     ! 
+      ! 
+      IF( lrst_oce )   CALL tke_rst( kt, 'WRITE' )
+      !
   END SUBROUTINE zdf_tke
 
@@ -207,5 +203,5 @@
       !! ** Method  : - TKE surface boundary condition
       !!              - source term due to Langmuir cells (Axell JGR 2002) (ln_lc=T)
-      !!              - source term due to shear (saved in avmu, avmv arrays)
+      !!              - source term due to shear (= Kz dz[Ub] * dz[Un] )
       !!              - Now TKE : resolution of the TKE equation by inverting
       !!                a tridiagonal linear system by a "methode de chasse"
@@ -213,6 +209,4 @@
       !!
       !! ** Action  : - en : now turbulent kinetic energy)
-      !!              - avmu, avmv : production of TKE by shear at u and v-points
-      !!                (= Kz dz[Ub] * dz[Un] )
       !! ---------------------------------------------------------------------
       INTEGER  ::   ji, jj, jk                      ! dummy loop arguments
@@ -228,5 +222,5 @@
       REAL(wp) ::   zzd_up, zzd_lw                  !    -         -
 !!bfr      REAL(wp) ::   zebot                           !    -         -
-      INTEGER , POINTER, DIMENSION(:,:  ) ::   imlc
+      INTEGER , DIMENSION(jpi,jpj) ::   imlc
       REAL(wp), POINTER, DIMENSION(:,:  ) ::   zhlc
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   zpelc, zdiag, zd_up, zd_lw, z3du, z3dv
@@ -236,5 +230,4 @@
       IF( nn_timing == 1 )  CALL timing_start('tke_tke')
       !
-      CALL wrk_alloc( jpi,jpj,       imlc )    ! integer
       CALL wrk_alloc( jpi,jpj,       zhlc ) 
       CALL wrk_alloc( jpi,jpj,jpk,   zpelc, zdiag, zd_up, zd_lw, z3du, z3dv ) 
@@ -473,7 +466,7 @@
          END DO
       ENDIF
+!!gm not sure we need this lbc ....
       CALL lbc_lnk( en, 'W', 1. )      ! Lateral boundary conditions (sign unchanged)
       !
-      CALL wrk_dealloc( jpi,jpj,       imlc )    ! integer
       CALL wrk_dealloc( jpi,jpj,       zhlc ) 
       CALL wrk_dealloc( jpi,jpj,jpk,   zpelc, zdiag, zd_up, zd_lw, z3du, z3dv ) 
@@ -516,11 +509,10 @@
       !!      with pdlr=1 if nn_pdl=0, pdlr=1/pdl=F(Ri) otherwise.
       !!
-      !! ** Action  : - avt : now vertical eddy diffusivity (w-point)
-      !!              - avmu, avmv : now vertical eddy viscosity at uw- and vw-points
+      !! ** Action  : - avt, avm : now vertical eddy diffusivity and viscosity (w-point)
       !!----------------------------------------------------------------------
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   zrn2, zraug, zcoef, zav     ! local scalars
-      REAL(wp) ::   zdku, zri, zsqen            !   -      -
-      REAL(wp) ::   zdkv, zemxl, zemlm, zemlp   !   -      -
+      REAL(wp) ::   zrn2, zraug, zcoef, zav   ! local scalars
+      REAL(wp) ::   zdku,   zdkv, zsqen       !   -      -
+      REAL(wp) ::   zemxl, zemlm, zemlp       !   -      -
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zmpdl, zmxlm, zmxld
       !!--------------------------------------------------------------------
@@ -645,5 +637,5 @@
 
       !                     !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      !                     !  Vertical eddy viscosity and diffusivity  (avmu, avmv, avt)
+      !                     !  Vertical eddy viscosity and diffusivity  (avm and avt)
       !                     !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       DO jk = 1, jpkm1            !* vertical eddy viscosity & diffivity at w-points
@@ -658,15 +650,5 @@
          END DO
       END DO
-      CALL lbc_lnk( avm, 'W', 1. )      ! Lateral boundary conditions (sign unchanged)
-      !
-      DO jk = 2, jpkm1            !* vertical eddy viscosity at wu- and wv-points
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               avmu(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji+1,jj  ,jk) ) * wumask(ji,jj,jk)
-               avmv(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji  ,jj+1,jk) ) * wvmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-      CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )      ! Lateral boundary conditions
+      !
       !
       IF( nn_pdl == 1 ) THEN      !* Prandtl number case: update avt
@@ -677,7 +659,4 @@
 # if defined key_c1d
                   e_pdl(ji,jj,jk) = apdlr(ji,jj,jk) * wmask(ji,jj,jk)    ! c1d configuration : save masked Prandlt number
-!!gm bug NO zri here....
-!!gm remove the specific diag for c1d !
-                  e_ric(ji,jj,jk) = zri * wmask(ji,jj,jk)                            ! c1d config. : save Ri
 # endif
               END DO
@@ -685,10 +664,11 @@
          END DO
       ENDIF
-      CALL lbc_lnk( avt, 'W', 1. )                      ! Lateral boundary conditions on avt  (sign unchanged)
+!!gm I'm sure this is needed to compute the shear term at next time-step
+      CALL lbc_lnk( avm, 'W', 1. )      ! Lateral boundary conditions (sign unchanged)
+      CALL lbc_lnk( avt, 'W', 1. )      ! Lateral boundary conditions on avt  (sign unchanged)
 
       IF(ln_ctl) THEN
-         CALL prt_ctl( tab3d_1=en  , clinfo1=' tke  - e: ', tab3d_2=avt, clinfo2=' t: ', ovlap=1, kdim=jpk)
-         CALL prt_ctl( tab3d_1=avmu, clinfo1=' tke  - u: ', mask1=umask,                   &
-            &          tab3d_2=avmv, clinfo2=       ' v: ', mask2=vmask, ovlap=1, kdim=jpk )
+         CALL prt_ctl( tab3d_1=en , clinfo1=' tke  - e: ', tab3d_2=avt, clinfo2=' t: ', ovlap=1, kdim=jpk)
+         CALL prt_ctl( tab3d_1=avm, clinfo1=' tke  - m: ', ovlap=1, kdim=jpk )
       ENDIF
       !
@@ -759,10 +739,9 @@
       ENDIF
       !
-      IF( ln_zdftmx ) THEN          ! Internal wave driven mixing
-         !                          ! specific values of rn_emin & rmxl_min are used
-         rn_emin  = 1.e-10_wp
-         rmxl_min = 1.e-03_wp
+      IF( ln_zdfiwm ) THEN          ! Internal wave-driven mixing
+         rn_emin  = 1.e-10_wp             ! specific values of rn_emin & rmxl_min are used
+         rmxl_min = 1.e-03_wp             ! associated avt minimum = molecular salt diffusivity (10^-9 m2/s)
          IF(lwp) WRITE(numout,*) '      Internal wave-driven mixing case:   force   rn_emin = 1.e-10 and rmxl_min = 1.e-3 '
-      ELSE
+      ELSE                          ! standard case : associated avt minimum = molecular viscosity (10^-6 m2/s)
          rmxl_min = 1.e-6_wp / ( rn_ediff * SQRT( rn_emin ) )    ! resulting minimum length to recover molecular viscosity
          IF(lwp) WRITE(numout,*) '      minimum mixing length with your parameters rmxl_min = ', rmxl_min
@@ -798,6 +777,4 @@
          avt (:,:,jk) = avtb(jk) * wmask (:,:,jk)
          avm (:,:,jk) = avmb(jk) * wmask (:,:,jk)
-         avmu(:,:,jk) = avmb(jk) * wumask(:,:,jk)
-         avmv(:,:,jk) = avmb(jk) * wvmask(:,:,jk)
       END DO
       dissl(:,:,:) = 1.e-12_wp
@@ -821,6 +798,6 @@
      CHARACTER(len=*), INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
      !
-     INTEGER ::   jit, jk   ! dummy loop indices
-     INTEGER ::   id1, id2, id3, id4, id5, id6   ! local integers
+     INTEGER ::   jit, jk              ! dummy loop indices
+     INTEGER ::   id1, id2, id3, id4   ! local integers
      !!----------------------------------------------------------------------
      !
@@ -829,40 +806,33 @@
         IF( ln_rstart ) THEN                   !* Read the restart file
            id1 = iom_varid( numror, 'en'   , ldstop = .FALSE. )
-           id2 = iom_varid( numror, 'avt'  , ldstop = .FALSE. )
-           id3 = iom_varid( numror, 'avm'  , ldstop = .FALSE. )
-           id4 = iom_varid( numror, 'avmu' , ldstop = .FALSE. )
-           id5 = iom_varid( numror, 'avmv' , ldstop = .FALSE. )
-           id6 = iom_varid( numror, 'dissl', ldstop = .FALSE. )
+           id2 = iom_varid( numror, 'avt_k', ldstop = .FALSE. )
+           id3 = iom_varid( numror, 'avm_k', ldstop = .FALSE. )
+           id4 = iom_varid( numror, 'dissl', ldstop = .FALSE. )
            !
            IF( id1 > 0 ) THEN                       ! 'en' exists
               CALL iom_get( numror, jpdom_autoglo, 'en', en )
-              IF( MIN( id2, id3, id4, id5, id6 ) > 0 ) THEN        ! all required arrays exist
-                 CALL iom_get( numror, jpdom_autoglo, 'avt'  , avt   )
-                 CALL iom_get( numror, jpdom_autoglo, 'avm'  , avm   )
-                 CALL iom_get( numror, jpdom_autoglo, 'avmu' , avmu  )
-                 CALL iom_get( numror, jpdom_autoglo, 'avmv' , avmv  )
+              IF( MIN( id2, id3, id4 ) > 0 ) THEN        ! all required arrays exist
+                 CALL iom_get( numror, jpdom_autoglo, 'avt_k', avt_k )
+                 CALL iom_get( numror, jpdom_autoglo, 'avm_k', avm_k )
                  CALL iom_get( numror, jpdom_autoglo, 'dissl', dissl )
               ELSE                                                 ! one at least array is missing
-                 CALL tke_avn                                          ! compute avt, avm, avmu, avmv and dissl (approximation)
+                 CALL tke_avn                                          ! compute avt, avm, and dissl (approximation)
               ENDIF
            ELSE                                     ! No TKE array found: initialisation
               IF(lwp) WRITE(numout,*) ' ===>>>> : previous run without tke scheme, en computed by iterative loop'
-              en (:,:,:) = rn_emin * tmask(:,:,:)
-              CALL tke_avn                               ! recompute avt, avm, avmu, avmv and dissl (approximation)
-              !
-              avt_k (:,:,:) = avt (:,:,:)
-              avm_k (:,:,:) = avm (:,:,:)
-              avmu_k(:,:,:) = avmu(:,:,:)
-              avmv_k(:,:,:) = avmv(:,:,:)
+              en (:,:,:) = rn_emin * wmask(:,:,:)
+              CALL tke_avn                               ! recompute avt, avm, and dissl (approximation)
+              avt_k(:,:,:) = avt(:,:,:)
+              avm_k(:,:,:) = avm(:,:,:)
               !
               DO jit = nit000 + 1, nit000 + 10   ;   CALL zdf_tke( jit )   ;   END DO
+              avt_k(:,:,:) = avt(:,:,:)
+              avm_k(:,:,:) = avm(:,:,:)
            ENDIF
         ELSE                                   !* Start from rest
            en(:,:,:) = rn_emin * tmask(:,:,:)
            DO jk = 1, jpk                           ! set the Kz to the background value
-              avt (:,:,jk) = avtb(jk) * wmask (:,:,jk)
-              avm (:,:,jk) = avmb(jk) * wmask (:,:,jk)
-              avmu(:,:,jk) = avmb(jk) * wumask(:,:,jk)
-              avmv(:,:,jk) = avmb(jk) * wvmask(:,:,jk)
+              avt_k(:,:,jk) = avtb(jk) * wmask (:,:,jk)
+              avm_k(:,:,jk) = avmb(jk) * wmask (:,:,jk)
            END DO
         ENDIF
@@ -871,10 +841,8 @@
         !                                   ! -------------------
         IF(lwp) WRITE(numout,*) '---- tke-rst ----'
-        CALL iom_rstput( kt, nitrst, numrow, 'en'   , en     )
-        CALL iom_rstput( kt, nitrst, numrow, 'avt'  , avt_k  )
-        CALL iom_rstput( kt, nitrst, numrow, 'avm'  , avm_k  )
-        CALL iom_rstput( kt, nitrst, numrow, 'avmu' , avmu_k )
-        CALL iom_rstput( kt, nitrst, numrow, 'avmv' , avmv_k )
-        CALL iom_rstput( kt, nitrst, numrow, 'dissl', dissl  )
+        CALL iom_rstput( kt, nitrst, numrow, 'en'   , en    )
+        CALL iom_rstput( kt, nitrst, numrow, 'avt_k', avt_k )
+        CALL iom_rstput( kt, nitrst, numrow, 'avm_k', avm_k )
+        CALL iom_rstput( kt, nitrst, numrow, 'dissl', dissl )
         !
      ENDIF
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/module_example
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/module_example	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/module_example	(revision 7990)
@@ -86,9 +86,4 @@
       !!                Give references if exist otherwise suppress these lines
       !!----------------------------------------------------------------------
-      USE toto_module      ! description of the module
-      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   zztab => wrk_2d_5                     ! 2D workspace
-      USE wrk_nemo, ONLY:   zwx => wrk_3d_12 , zwy => wrk_3d_13   ! 3D workspace
-      !!
       INTEGER , INTENT(in   )                     ::   kt      ! short description 
       INTEGER , INTENT(inout)                     ::   pvar1   !   -         -
@@ -100,10 +95,7 @@
       REAL(wp) ::   zmlmin, zbbrau   ! temporary scalars     (DOCTOR : start with z)
       REAL(wp) ::   zfact1, zfact2   ! do not use continuation lines in declaration
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwrk_2d   ! 2D workspace
       !!--------------------------------------------------------------------
-
-      IF( wrk_in_use(3, 12,13) .OR. wrk_in_use(2, 5 ) THEN
-         CALL ctl_stop('exa_mpl: requested workspace arrays unavailable')   ;   RETURN
-      ENDIF
-
+      !
       IF( kt == nit000  )   CALL exa_mpl_init    ! Initialization (first time-step only)
 
@@ -119,5 +111,5 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  avmv(ji,jj,jk) = ....
+                  avm(ji,jj,jk) = ....
                END DO
             END DO
@@ -128,5 +120,5 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  avmv(ji,jj,jk) = ...
+                  avm(ji,jj,jk) = ...
                END DO
             END DO
@@ -135,9 +127,5 @@
       END SELECT
       !
-      CALL mpplnk2( avmu, 'U', 1. )              ! Lateral boundary conditions (unchanged sign)
-      !
-      IF( wrk_not_released(3, 12,13) .OR. wrk_not_released(2, 5 ) THEN
-         CALL ctl_stop('exa_mpl: failed to release workspace arrays')   ;   RETURN
-      ENDIF
+      CALL lbc_lnk( avm, 'T', 1. )              ! Lateral boundary conditions (unchanged sign)
       !
    END SUBROUTINE exa_mpl
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7990)
@@ -64,15 +64,4 @@
 
    USE zdfphy         ! vertical physics manager      (zdf_phy_init routine)
-!!gm to be suppressed
-   USE zdftmx           ! tide-induced vertical mixing     (zdf_tmx routine)
-   USE zdfbfr           ! bottom friction                  (zdf_bfr routine)
-   USE zdftke           ! TKE vertical mixing              (zdf_tke routine)
-   USE zdfgls           ! GLS vertical mixing              (zdf_gls routine)
-   USE zdfddm           ! double diffusion mixing          (zdf_ddm routine)
-   USE zdfevd           ! enhanced vertical diffusion      (zdf_evd routine)
-   USE zdfric           ! Richardson vertical mixing       (zdf_ric routine)
-   USE zdfmxl           ! Mixed-layer depth                (zdf_mxl routine)
-   USE zdfqiao          !Qiao module wave induced mixing   (zdf_qiao routine)
-!!gm end
 
    USE step_diu        ! Time stepping for diurnal sst
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7990)
@@ -119,5 +119,5 @@
       !                                          ! --------------
       neln(:,:) = 1                                   ! euphotic layer level
-      DO jk = 1, jpk                                  ! (i.e. 1rst T-level strictly below EL bottom)
+      DO jk = 1, jpkm1                                ! (i.e. 1rst T-level strictly below EL bottom)
          DO jj = 1, jpj
            DO ji = 1, jpi
@@ -147,4 +147,5 @@
    END SUBROUTINE p2z_opt
 
+
    SUBROUTINE p2z_opt_init
       !!----------------------------------------------------------------------
